summaryrefslogtreecommitdiff
path: root/scripts/lf
diff options
context:
space:
mode:
Diffstat (limited to 'scripts/lf')
-rwxr-xr-xscripts/lf/cleaner3
-rwxr-xr-xscripts/lf/lfub34
-rwxr-xr-xscripts/lf/preview65
3 files changed, 102 insertions, 0 deletions
diff --git a/scripts/lf/cleaner b/scripts/lf/cleaner
new file mode 100755
index 0000000..0159d5a
--- /dev/null
+++ b/scripts/lf/cleaner
@@ -0,0 +1,3 @@
+#!/bin/sh
+
+ueberzugpp cmd -s $UB_SOCKET -a remove -i PREVIEW
diff --git a/scripts/lf/lfub b/scripts/lf/lfub
new file mode 100755
index 0000000..45864e5
--- /dev/null
+++ b/scripts/lf/lfub
@@ -0,0 +1,34 @@
+#!/bin/sh
+
+# This is a wrapper script for lf that allows it to create image previews with
+# ueberzug. This works in concert with the lf configuration file and the
+# lf-cleaner script.
+
+set -e
+
+UB_PID=0
+UB_SOCKET=""
+
+case "$(uname -a)" in
+ *Darwin*) UEBERZUG_TMP_DIR="$TMPDIR" ;;
+ *) UEBERZUG_TMP_DIR="/tmp" ;;
+esac
+
+cleanup() {
+ exec 3>&-
+ ueberzugpp cmd -s "$UB_SOCKET" -a exit
+}
+
+if [ -n "$SSH_CLIENT" ] || [ -n "$SSH_TTY" ]; then
+ lf "$@"
+else
+ [ ! -d "$HOME/.cache/lf" ] && mkdir -p "$HOME/.cache/lf"
+ UB_PID_FILE="$UEBERZUG_TMP_DIR/.$(uuidgen)"
+ ueberzugpp layer --silent --no-stdin --use-escape-codes --pid-file "$UB_PID_FILE"
+ UB_PID=$(cat "$UB_PID_FILE")
+ rm "$UB_PID_FILE"
+ UB_SOCKET="$UEBERZUG_TMP_DIR/ueberzugpp-${UB_PID}.socket"
+ export UB_PID UB_SOCKET
+ trap cleanup HUP INT QUIT TERM EXIT
+ lf "$@" 3>&-
+fi
diff --git a/scripts/lf/preview b/scripts/lf/preview
new file mode 100755
index 0000000..ab41c61
--- /dev/null
+++ b/scripts/lf/preview
@@ -0,0 +1,65 @@
+#!/bin/sh
+
+image() {
+ FILE_PATH="$1"
+ X=$4
+ Y=$5
+ MW=$(($2 - 1))
+ MH=$3
+ ueberzugpp cmd -s "$UB_SOCKET" -a add -i PREVIEW -x "$X" -y "$Y" --max-width "$MW" --max-height "$MH" -f "$FILE_PATH"
+ exit 1
+}
+
+batorcat() {
+ file="$1"
+ shift
+ if command -v bat >/dev/null 2>&1; then
+ bat --color=always --style=plain --pager=never "$file" "$@"
+ else
+ cat "$file"
+ fi
+}
+
+CACHE="$HOME/.cache/lf/thumbnail.$(stat --printf '%n\0%i\0%F\0%s\0%W\0%Y' -- "$(readlink -f "$1")" | sha256sum | awk '{print $1}'))"
+
+case "$(printf "%s\n" "$(readlink -f "$1")" | tr '[:upper:]' '[:lower:]')" in
+ *.tgz | *.tar.gz) tar tzf "$1" ;;
+ *.tar.bz2 | *.tbz2) tar tjf "$1" ;;
+ *.tar.txz | *.txz) xz --list "$1" ;;
+ *.tar) tar tf "$1" ;;
+ *.zip | *.jar | *.war | *.ear | *.oxt) unzip -l "$1" ;;
+ *.rar) unrar l "$1" ;;
+ *.7z) 7z l "$1" ;;
+ *.[1-8]) man "$1" | col -b ;;
+ *.o) nm "$1" ;;
+ *.torrent) transmission-show "$1" ;;
+ *.iso) iso-info --no-header -l "$1" ;;
+ *.odt | *.ods | *.odp | *.sxw) odt2txt "$1" ;;
+ *.doc) catdoc "$1" ;;
+ *.docx) docx2txt "$1" - ;;
+ *.xls | *.xlsx)
+ ssconvert --export-type=Gnumeric_stf:stf_csv "$1" "fd://1" | batorcat --language=csv
+ ;;
+ *.wav | *.mp3 | *.flac | *.m4a | *.wma | *.ape | *.ac3 | *.og[agx] | *.spx | *.opus | *.as[fx] | *.mka)
+ exiftool "$1"
+ ;;
+ *.pdf)
+ [ ! -f "${CACHE}.jpg" ] && pdftoppm -jpeg -f 1 -singlefile "$1" "$CACHE"
+ image "${CACHE}.jpg" "$2" "$3" "$4" "$5"
+ ;;
+ *.avi | *.mp4 | *.wmv | *.dat | *.3gp | *.ogv | *.mkv | *.mpg | *.mpeg | *.vob | *.fl[icv] | *.m2v | *.mov | *.webm | *.ts | *.mts | *.m4v | *.r[am] | *.qt | *.divx)
+ [ ! -f "${CACHE}.jpg" ] && ffmpegthumbnailer -i "$1" -o "${CACHE}.jpg" -s 0 -q 5
+ image "${CACHE}.jpg" "$2" "$3" "$4" "$5"
+ ;;
+ *.bmp | *.jpg | *.jpeg | *.png | *.xpm | *.webp | *.gif | *.jfif)
+ image "$1" "$2" "$3" "$4" "$5"
+ ;;
+ *.svg)
+ [ ! -f "${CACHE}.jpg" ] && convert "$1" "${CACHE}.jpg"
+ image "${CACHE}.jpg" "$2" "$3" "$4" "$5"
+ ;;
+ *)
+ batorcat "$1"
+ ;;
+esac
+exit 0